diff --git a/hwloc/topology-windows.c b/hwloc/topology-windows.c
index c0d1f2977a..bbd0ea5763 100644
--- a/hwloc/topology-windows.c
+++ b/hwloc/topology-windows.c
@@ -268,6 +268,7 @@ static void hwloc_win_get_function_ptrs(void)
 
     if (GetActiveProcessorGroupCountProc)
       nr_processor_groups = GetActiveProcessorGroupCountProc();
+printf("[windows] found %lu processor groups\n", nr_processor_groups);
 
     if (!QueryWorkingSetExProc) {
       HMODULE psapi = LoadLibrary("psapi.dll");
@@ -402,21 +403,8 @@ hwloc_win_get_thisthread_last_cpu_location(hwloc_topology_t topology __hwloc_att
 /* TODO: SetThreadIdealProcessor{,Ex} */
 
 static int
-hwloc_win_set_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused, hwloc_thread_t thread, hwloc_const_bitmap_t hwloc_set, int flags)
+hwloc_win__set_thread_cpubind(hwloc_thread_t thread, unsigned group, DWORD_PTR mask)
 {
-  DWORD_PTR mask;
-  unsigned group;
-
-  if (flags & HWLOC_CPUBIND_NOMEMBIND) {
-    errno = ENOSYS;
-    return -1;
-  }
-
-  if (hwloc_bitmap_to_single_ULONG_PTR(hwloc_set, &group, &mask) < 0) {
-    errno = ENOSYS;
-    return -1;
-  }
-
   assert(nr_processor_groups == 1 || SetThreadGroupAffinityProc);
 
   if (nr_processor_groups > 1) {
@@ -436,6 +424,25 @@ hwloc_win_set_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused,
   return 0;
 }
 
+static int
+hwloc_win_set_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused, hwloc_thread_t thread, hwloc_const_bitmap_t hwloc_set, int flags)
+{
+  DWORD_PTR mask;
+  unsigned group;
+
+  if (flags & HWLOC_CPUBIND_NOMEMBIND) {
+    errno = ENOSYS;
+    return -1;
+  }
+
+  if (hwloc_bitmap_to_single_ULONG_PTR(hwloc_set, &group, &mask) < 0) {
+    errno = ENOSYS;
+    return -1;
+  }
+
+  return hwloc_win__set_thread_cpubind(thread, group, mask);
+}
+
 static int
 hwloc_win_set_thisthread_cpubind(hwloc_topology_t topology, hwloc_const_bitmap_t hwloc_set, int flags)
 {
@@ -474,7 +481,7 @@ hwloc_win_set_thisthread_membind(hwloc_topology_t topology, hwloc_const_nodeset_
  */
 
 static int
-hwloc_win_get_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused, hwloc_thread_t thread, hwloc_cpuset_t set, int flags __hwloc_attribute_unused)
+hwloc_win__get_thread_cpubind(hwloc_thread_t thread, unsigned *group, DWORD_PTR *mask)
 {
   GROUP_AFFINITY aff;
 
@@ -482,7 +489,19 @@ hwloc_win_get_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused,
 
   if (!GetThreadGroupAffinityProc(thread, &aff))
     return -1;
-  hwloc_bitmap_from_ith_ULONG_PTR(set, aff.Group, aff.Mask);
+  *group = aff.Group;
+  *mask = aff.Mask;
+  return 0;
+}
+
+static int
+hwloc_win_get_thread_cpubind(hwloc_topology_t topology __hwloc_attribute_unused, hwloc_thread_t thread, hwloc_cpuset_t set, int flags __hwloc_attribute_unused)
+{
+  DWORD_PTR mask;
+  unsigned group;
+  if (hwloc_win__get_thread_cpubind(thread, &group, &mask) < 0)
+    return -1;
+  hwloc_bitmap_from_ith_ULONG_PTR(set, group, mask);
   return 0;
 }
 
@@ -639,6 +658,59 @@ hwloc_win_get_thisproc_membind(hwloc_topology_t topology, hwloc_nodeset_t nodese
 }
 
 
+/***************************
+ * saving_restoring binding
+ */
+
+struct hwloc_win_binding_private_data {
+  unsigned group; /* the current processor group */
+  DWORD_PTR thread_mask; /* the current thread mask inside the processor group */
+  DWORD_PTR process_mask; /* the current process mask inside the processor group */
+};
+
+static int
+hwloc_win_save_binding(hwloc_topology_t topology __hwloc_attribute_unused, void **private_data_p)
+{
+  struct hwloc_win_binding_private_data *pd;
+  DWORD_PTR sys_mask;
+  
+  pd = malloc(sizeof(*pd));
+  if (!pd)
+    return -1;
+
+  /* save current process binding */
+  if (!GetProcessAffinityMask(GetCurrentProcess(), &pd->process_mask, &sys_mask)) {
+    free(pd);
+    return -1;
+  }
+
+  /* save current thread binding */
+  if (hwloc_win__get_thread_cpubind(GetCurrentThread(), &pd->group, &pd->thread_mask) < 0) {
+    free(pd);
+    return -1;
+  }
+
+  *private_data_p = pd;
+  return 0;
+}
+
+static int
+hwloc_win_restore_binding(hwloc_topology_t topology __hwloc_attribute_unused, void *private_data_p)
+{
+  struct hwloc_win_binding_private_data *pd = private_data_p;
+  int err;
+
+  /* restore current thread binding first, so that the process moves to the right processor group */
+  err = hwloc_win__set_thread_cpubind(GetCurrentThread(), pd->group, pd->thread_mask);
+
+  /* now restore the process binding inside that processor group */
+  if (!SetProcessAffinityMask(GetCurrentProcess(), pd->process_mask))
+    err = -1;
+
+  free(pd);
+  return err;
+}
+
 /************************
  * membind alloc/free
  */
@@ -1188,6 +1260,10 @@ hwloc_set_windows_hooks(struct hwloc_binding_hooks *hooks,
     hooks->get_thisthread_cpubind = hwloc_win_get_thisthread_cpubind;
     hooks->get_thisthread_membind = hwloc_win_get_thisthread_membind;
   }
+  if (GetThreadGroupAffinityProc && (nr_processor_groups == 1 || SetThreadGroupAffinityProc)) {
+    hooks->save_binding = hwloc_win_save_binding;
+    hooks->restore_binding = hwloc_win_restore_binding;
+  }
 
   if (VirtualAllocExNumaProc) {
     hooks->alloc_membind = hwloc_win_alloc_membind;
diff --git a/hwloc/topology-x86.c b/hwloc/topology-x86.c
index 5cc6acf16c..574e35d23e 100644
--- a/hwloc/topology-x86.c
+++ b/hwloc/topology-x86.c
@@ -1234,20 +1234,34 @@ static int
 look_procs(struct hwloc_backend *backend, struct procinfo *infos, unsigned long flags,
 	   unsigned highest_cpuid, unsigned highest_ext_cpuid, unsigned *features, enum cpuid_type cpuid_type,
 	   int (*get_cpubind)(hwloc_topology_t topology, hwloc_cpuset_t set, int flags),
-	   int (*set_cpubind)(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags))
+	   int (*set_cpubind)(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags),
+           int (*save_binding)(hwloc_topology_t topology, void **private_data),
+           int (*restore_binding)(hwloc_topology_t topology, void *private_data))
+
 {
   struct hwloc_x86_backend_data_s *data = backend->private_data;
   struct hwloc_topology *topology = backend->topology;
   unsigned nbprocs = data->nbprocs;
+  void *binding_private_data = NULL;
   hwloc_bitmap_t orig_cpuset = NULL;
   hwloc_bitmap_t set = NULL;
   unsigned i;
 
+  assert(!save_binding == !restore_binding); /* we want either both or none */
+
   if (!data->src_cpuiddump_path) {
-    orig_cpuset = hwloc_bitmap_alloc();
-    if (get_cpubind(topology, orig_cpuset, HWLOC_CPUBIND_STRICT)) {
-      hwloc_bitmap_free(orig_cpuset);
-      return -1;
+    if (save_binding) {
+      /* only use the save/restore_binding hooks */
+      if (save_binding(topology, &binding_private_data) < 0) {
+        return -1;
+      }
+    } else {
+      /* just use the get/set_cpubind hooks for saving/restoring */
+      orig_cpuset = hwloc_bitmap_alloc();
+      if (get_cpubind(topology, orig_cpuset, HWLOC_CPUBIND_STRICT)) {
+        hwloc_bitmap_free(orig_cpuset);
+        return -1;
+      }
     }
     set = hwloc_bitmap_alloc();
   }
@@ -1275,9 +1289,15 @@ look_procs(struct hwloc_backend *backend, struct procinfo *infos, unsigned long
   }
 
   if (!data->src_cpuiddump_path) {
-    set_cpubind(topology, orig_cpuset, 0);
+    if (restore_binding) {
+      /* only use the save/restore_binding hooks */
+      restore_binding(topology, binding_private_data);
+    } else {
+      /* just use the get/set_cpubind hooks for saving/restoring */
+      set_cpubind(topology, orig_cpuset, 0);
+      hwloc_bitmap_free(orig_cpuset);
+    }
     hwloc_bitmap_free(set);
-    hwloc_bitmap_free(orig_cpuset);
   }
 
   if (data->apicid_unique)
@@ -1369,6 +1389,8 @@ int hwloc_look_x86(struct hwloc_backend *backend, unsigned long flags)
   struct hwloc_topology_membind_support memsupport __hwloc_attribute_unused;
   int (*get_cpubind)(hwloc_topology_t topology, hwloc_cpuset_t set, int flags) = NULL;
   int (*set_cpubind)(hwloc_topology_t topology, hwloc_const_cpuset_t set, int flags) = NULL;
+  int (*save_binding)(hwloc_topology_t topology, void **private_data) = NULL;
+  int (*restore_binding)(hwloc_topology_t topology, void *private_data) = NULL;
   struct cpuiddump *src_cpuiddump = NULL;
   int ret = -1;
 
@@ -1391,6 +1413,10 @@ int hwloc_look_x86(struct hwloc_backend *backend, unsigned long flags)
      * but the current overhead is negligible, so just always reget them.
      */
     hwloc_set_native_binding_hooks(&hooks, &support);
+
+    save_binding = hooks.save_binding;
+    restore_binding = hooks.restore_binding;
+
     if (hooks.get_thisthread_cpubind && hooks.set_thisthread_cpubind) {
       get_cpubind = hooks.get_thisthread_cpubind;
       set_cpubind = hooks.set_thisthread_cpubind;
@@ -1402,7 +1428,10 @@ int hwloc_look_x86(struct hwloc_backend *backend, unsigned long flags)
       get_cpubind = hooks.get_thisproc_cpubind;
       set_cpubind = hooks.set_thisproc_cpubind;
     } else {
-      /* we need binding support if there are multiple PUs */
+      /* we need binding support if there are multiple PUs.
+       * FIXME: could work if we have set_cpubind + save/restore_binding without get_cpubind,
+       * but that's unlikely to ever happen in any backend.
+       */
       if (nbprocs > 1)
 	goto out;
       get_cpubind = fake_get_cpubind;
@@ -1473,7 +1502,9 @@ int hwloc_look_x86(struct hwloc_backend *backend, unsigned long flags)
 
   ret = look_procs(backend, infos, flags,
 		   highest_cpuid, highest_ext_cpuid, features, cpuid_type,
-		   get_cpubind, set_cpubind);
+		   get_cpubind, set_cpubind,
+                   save_binding, restore_binding);
+
   if (!ret)
     /* success, we're done */
     goto out_with_os_state;
@@ -1500,6 +1531,10 @@ int hwloc_look_x86(struct hwloc_backend *backend, unsigned long flags)
 out:
   if (src_cpuiddump)
     cpuiddump_free(src_cpuiddump);
+#ifdef HWLOC_WIN_SYS
+  printf("[x86] restorring process mask %llu\n", (unsigned long long) mask);
+  SetProcessAffinityMask(GetCurrentProcess(), mask);
+#endif
   return ret;
 }
 
diff --git a/include/private/private.h b/include/private/private.h
index 6f9f7a2797..2225a64277 100644
--- a/include/private/private.h
+++ b/include/private/private.h
@@ -40,7 +40,7 @@
 #endif
 #include <string.h>
 
-#define HWLOC_TOPOLOGY_ABI 0x20300 /* version of the layout of struct topology */
+#define HWLOC_TOPOLOGY_ABI 0x20400 /* version of the layout of struct topology */
 
 struct hwloc_internal_location_s {
   enum hwloc_location_type_e type;
@@ -133,6 +133,8 @@ struct hwloc_topology {
     int (*free_membind)(hwloc_topology_t topology, void *addr, size_t len);
 
     int (*get_allowed_resources)(hwloc_topology_t topology);
+    int (*save_binding)(hwloc_topology_t topology, void **private_data);
+    int (*restore_binding)(hwloc_topology_t topology, void *private_data);
   } binding_hooks;
 
   struct hwloc_topology_support support;
diff --git a/tests/hwloc/hwloc_topology_abi.c b/tests/hwloc/hwloc_topology_abi.c
index 32f5cc916f..2b0bb5068d 100644
--- a/tests/hwloc/hwloc_topology_abi.c
+++ b/tests/hwloc/hwloc_topology_abi.c
@@ -55,18 +55,18 @@ int main(void)
     offset = offsetof(struct hwloc_topology, binding_hooks);
     assert(offset == 456);
     size = sizeof(struct hwloc_binding_hooks);
-    assert(size == 192);
+    assert(size == 208);
 
     offset = offsetof(struct hwloc_topology, support);
-    assert(offset == 648);
+    assert(offset == 664);
 
     offset = offsetof(struct hwloc_topology, first_dist);
-    assert(offset == 704);
+    assert(offset == 720);
     size = sizeof(struct hwloc_internal_distances_s);
     assert(size == 88);
 
     offset = offsetof(struct hwloc_topology, memattrs);
-    assert(offset == 728);
+    assert(offset == 744);
     size = sizeof(struct hwloc_internal_memattr_s);
     assert(size == 32);
     size = sizeof(struct hwloc_internal_memattr_target_s);
@@ -77,7 +77,7 @@ int main(void)
     assert(size == 32);
 
     offset = offsetof(struct hwloc_topology, grouping_next_subkind);
-    assert(offset == 768);
+    assert(offset == 784);
 
     /* fields after this one aren't needed after discovery */
 
